/*!
 * Copyright (c) 2012 - 2021, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  var define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"7e6ecbb3c3": function _(e,s,t,i,n){i();const o=e("tslib").__importStar(e("6ed169d807"));t.PanelChemistryExtensions=o;e("@bokehjs/base").register_models(o)},
"6ed169d807": function _(E,i,o,t,c){t(),c("JSMEEditor",E("935e6c4794").JSMEEditor)},
"935e6c4794": function _(e,s,t,i,o){i();const l=e("@bokehjs/models/layouts/html_box"),n=e("@bokehjs/core/dom");const h="Not Subscribed";function m(e){var s=e.getMultiSDFstack(),t="No multirecords SDF was pasted into the editor ";return s.length>0&&(t=s.join("$$$$\n")+"$$$$\n"),t}function r(e,s){console.log("setValue - start",e.value);var t=e.value;"smiles"===e.format?(console.log("getting smiles"),t=s.smiles(),console.log("got smiles")):t="mol"===e.format?s.molFile(!1):"mol3000"===e.format?s.molFile(!0):"sdf"===e.format?m(s):s.jmeFile(),e.value!==t&&null!==t&&(console.log("setting value",t),e.value=t),console.log("setValue - end",e.value)}function c(e,s){console.log("setValues - start"),r(e,s),function(e,s){console.log("setOtherValues - start"),e.subscriptions.includes("jme")&&(e.jme=u(s.jmeFile()));e.subscriptions.includes("smiles")&&(e.smiles=u(s.smiles()));e.subscriptions.includes("mol")&&(e.mol=u(s.molFile(!1)));e.subscriptions.includes("mol3000")&&(e.mol3000=u(s.molFile(!0)));e.subscriptions.includes("sdf")&&(e.sdf=u(m(s)));console.log("setOtherValues - end")}(e,s),console.log("setValues - end")}function d(e,s){e.subscriptions.includes("jme")||(e.jme=h),e.subscriptions.includes("smiles")||(e.smiles=h),e.subscriptions.includes("mol")||(e.mol=h),e.subscriptions.includes("mol3000")||(e.mol3000=h),e.subscriptions.includes("sdf")||(e.sdf=h),c(e,s)}function u(e){return null===e?"null":e}class a extends l.HTMLBoxView{constructor(){super(...arguments),this.JSME=window.JSApplet.JSME,this.valueChanging=!0}connect_signals(){super.connect_signals(),this.connect(this.model.properties.value.change,(()=>{console.log("value change",this.model.value),this.valueChanging||(""===this.model.value?this.jsmeElement.reset():this.jsmeElement.readGenericMolecularInput(this.model.value))})),this.connect(this.model.properties.format.change,(()=>{console.log("format change",this.model.format),r(this.model,this.jsmeElement)})),this.connect(this.model.properties.subscriptions.change,(()=>{console.log("subscriptions change",this.model.subscriptions),d(this.model,this.jsmeElement)})),this.connect(this.model.properties.options.change,(()=>{console.log("options change",this.model.options),this.setJSMEOptions()}))}render(){console.log("render - start"),super.render();const e="jsme-"+"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,(function(e){var s=16*Math.random()|0;return("x"==e?s:3&s|8).toString(16)})),s=n.div({class:"jsme-editor",id:e});this.el.appendChild(s),this.jsmeElement=new this.JSME(e,this.getHeight(),this.getWidth(),{}),this.jsmeElement.readGenericMolecularInput(this.model.value),d(this.model,this.jsmeElement),this.setJSMEOptions();const t=this;this.jsmeElement.setAfterStructureModifiedCallback((function(e){console.log("event",e),t.valueChanging=!0,c(t.model,t.jsmeElement),t.valueChanging=!1})),c(this.model,this.jsmeElement),console.log("render - end")}setJSMEOptions(){const e=this.model.options.join(",");console.log("options",e),this.jsmeElement.options(e)}getHeight(){return"stretch_height"!==this.model.sizing_mode&&"stretch_both"!==this.model.sizing_mode||!this.el.style.height?this.model.height?this.model.height.toString()+"px":"100px":this.el.style.height}getWidth(){return"stretch_width"!==this.model.sizing_mode&&"stretch_both"!==this.model.sizing_mode||!this.el.style.width?this.model.width?this.model.width.toString()+"px":"100px":this.el.style.width}resizeJSMEElement(){this.jsmeElement.setSize(this.getWidth(),this.getHeight())}after_layout(){super.after_layout(),this.resizeJSMEElement()}}t.JSMEEditorView=a,a.__name__="JSMEEditorView";class g extends l.HTMLBox{constructor(e){super(e)}static init_JSMEEditor(){this.prototype.default_view=a,this.define((({String:e,Array:s})=>({value:[e,""],format:[e,""],options:[s(e),[]],jme:[e,""],smiles:[e,""],mol:[e,""],mol3000:[e,""],sdf:[e,""],subscriptions:[s(e),[]]})))}}t.JSMEEditor=g,g.__name__="JSMEEditor",g.__module__="panel_chemistry.bokeh_extensions.jsme_editor",g.init_JSMEEditor()},
}, "7e6ecbb3c3", {"index":"7e6ecbb3c3","bokeh_extensions/index":"6ed169d807","bokeh_extensions/jsme_editor":"935e6c4794"}, {});});
